package behavior.odd.oddbehaviordemo;

import android.app.Activity;
import android.app.admin.DevicePolicyManager;
import android.app.enterprise.EnterpriseDeviceManager;
import android.app.enterprise.SecurityPolicy;

import android.content.ComponentName;
import android.content.Intent;
import android.security.KeyChain;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.util.Base64;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Toast;

import com.sec.enterprise.knox.license.KnoxEnterpriseLicenseManager;
import android.app.enterprise.license.EnterpriseLicenseManager;

import java.util.List;


public class MainActivity extends AppCompatActivity {
    public static final String TAG = "OddBehaviorDemo";
    private DevicePolicyManager mDPM;
    private ComponentName mDeviceAdminSample;
    private static final String pkgName = "behavior.odd.oddbehaviordemo";

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode, Intent data) {
        if (requestCode == 102) {
            if (resultCode == Activity.RESULT_OK) {
                Toast.makeText(this, "Device administrator setup successful.", Toast.LENGTH_SHORT).show();
                Log.d(TAG,"Device administrator setup successful");
            } else {
                Toast.makeText(this, "Device administrator setup failed.", Toast.LENGTH_SHORT).show();
                Log.d(TAG, "Device administrator setup failed");
            }
            return;
        }
        super.onActivityResult(requestCode, resultCode, data);
    }


    public void setupAdmin(View view) {
        OddBehaviorDemoReceiver pr = new OddBehaviorDemoReceiver();
        mDPM = (DevicePolicyManager) pr.getManager(getApplicationContext());
        mDeviceAdminSample = OddBehaviorDemoReceiver.getComponentName(getApplicationContext());
        if(!mDPM.isAdminActive(mDeviceAdminSample)) {
            Intent intent = new Intent(DevicePolicyManager.ACTION_ADD_DEVICE_ADMIN);
            intent.putExtra(DevicePolicyManager.EXTRA_DEVICE_ADMIN, mDeviceAdminSample);
            intent.putExtra(DevicePolicyManager.EXTRA_ADD_EXPLANATION, "Required for silent installation of certificates and PKCS #12 files");
            startActivityForResult(intent, 102);
        }
    }

    public void enterpriseLicense(View view) {
        try {
            String elmLicense = "<ELM LICENSE GOES HERE>";
            EnterpriseLicenseManager.getInstance(getApplicationContext()).activateLicense(elmLicense, pkgName);
            Toast.makeText(this, "Initialized Samsung Enterprise license", Toast.LENGTH_SHORT).show();
        }
        catch(Exception e)
        {
            StringBuilder sb = new StringBuilder();
            sb.append("Failed to initialize Samsung enterprise license: ");
            sb.append(e.toString());
            Toast.makeText(this, sb.toString(), Toast.LENGTH_SHORT).show();
            Log.e(TAG,"Failed to initialize Samsung licenses", e);
        }
    }
    public void knoxLicense(View view) {
        try {
            String knoxLicense = "<KLM LICENSE GOES HERE>"; // Use KLM license key
            KnoxEnterpriseLicenseManager.getInstance(getApplicationContext()).activateLicense(knoxLicense, pkgName);
            Toast.makeText(this, "Initialized Knox license", Toast.LENGTH_SHORT).show();
        }
        catch(Exception e)
        {
            StringBuilder sb = new StringBuilder();
            sb.append("Failed to initialize Samsung Knox license: ");
            sb.append(e.toString());
            Toast.makeText(this, sb.toString(), Toast.LENGTH_SHORT).show();
            Log.e(TAG,"Failed to initialize Samsung licenses", e);
        }
    }

    public void installCert(View view) {
        String x = "MIIDRzCCAi+gAwIBAgIBATANBgkqhkiG9w0BAQsFADBFMQswCQYDVQQGEwJVUzEf\n" +
                "MB0GA1UEChMWVGVzdCBDZXJ0aWZpY2F0ZXMgMjAxMTEVMBMGA1UEAxMMVHJ1c3Qg\n" +
                "QW5jaG9yMB4XDTEwMDEwMTA4MzAwMFoXDTMwMTIzMTA4MzAwMFowRTELMAkGA1UE\n" +
                "BhMCVVMxHzAdBgNVBAoTFlRlc3QgQ2VydGlmaWNhdGVzIDIwMTExFTATBgNVBAMT\n" +
                "DFRydXN0IEFuY2hvcjCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBALmZ\n" +
                "UYkRR+DNRbmEJ4ITAhbNRDmqrNsJw97iLE7bpFeflDUoNcJrZPZbC208bG+g5M0A\n" +
                "TzV0vOqg88Ds1/FjFDK1oPItqsiDImJIq0xb/et5w72WNPxHVrcsr7Ap6DHfdwLp\n" +
                "NMncqtzX92hU/iGVHLE/w/OCWwAIIbTHaxdrGMUG7DkJJ6iI7mzqpcyPvyAAo9O3\n" +
                "SHjJr+uw5vSrHRretnV2un0bohvGslN64MY/UIiRnPFwd2gD76byDzoM1ioyLRCl\n" +
                "lfBJ5sRDz9xrUHNigTAUdlblb6yrnNtNJmkrROYvkh6sLETUh9EYh0Ar+94fZVXf\n" +
                "GVi57Sw7x1jyANTlA40CAwEAAaNCMEAwHQYDVR0OBBYEFOR9X9FclYYILAWuvnW2\n" +
                "ZafZXahmMA4GA1UdDwEB/wQEAwIBBjAPBgNVHRMBAf8EBTADAQH/MA0GCSqGSIb3\n" +
                "DQEBCwUAA4IBAQCYoa9uR55KJTkpwyPihIgXHq7/Z8dx3qZlCJQwE5qQBZXIsf5e\n" +
                "C8Va/QjnTHOC4Gt4MwpnqqmoDqyqSW8pBVQgAUFAXqO91nLCQb4+/yfjiiNjzprp\n" +
                "xQlcqIZYjJSVtckH1IDWFLFeuGW+OgPPEFgN4hjU5YFIsE2r1i4+ixkeuorxxsK1\n" +
                "D/jYbVwQMXLqn1pjJttOPJwuA8+ho1f2c8FrKlqjHgOwxuHhsiGN6MKgs1baalpR\n" +
                "/lnNFCIpq+/+3cnhufDjvxMy5lg+cwgMCiGzCxn4n4dBMw41C+4KhNF7ZtKuKSZ1\n" +
                "eczztXD9NUkGUGw3LzpLDJazz3JhlZ/9pXzF";
        byte[] data = Base64.decode(x, Base64.DEFAULT);

        boolean installed = false;
        EnterpriseDeviceManager edm = (EnterpriseDeviceManager) getSystemService(EnterpriseDeviceManager.ENTERPRISE_POLICY_SERVICE);
        SecurityPolicy mSecurityPolicy = edm.getSecurityPolicy();
        try {
            boolean retValue = mSecurityPolicy.installCertificateToKeystore(SecurityPolicy.TYPE_CERTIFICATE, data, "nickname", null, SecurityPolicy.KEYSTORE_DEFAULT | SecurityPolicy.KEYSTORE_FOR_VPN_AND_APPS | SecurityPolicy.KEYSTORE_FOR_WIFI);
            if (retValue) {
                Toast.makeText(this, "Successfully installed certificate", Toast.LENGTH_SHORT).show();
                installed = true;
            }
            else
            {
                Toast.makeText(this, "Failed to install cert", Toast.LENGTH_SHORT).show();
            }

        }
        catch(Exception e)
        {
            Log.e(TAG, "Failed to add certificate in test code", e);
            Toast.makeText(this, "Caught exception while trying to install cert: " + e.toString(), Toast.LENGTH_SHORT).show();
        }
        if(!installed)
        {
            Intent intent = KeyChain.createInstallIntent();
            intent.putExtra(KeyChain.EXTRA_CERTIFICATE, data);
            intent.putExtra(KeyChain.EXTRA_NAME, "nickname");
            Log.d(TAG, "Starting certificate installation for certificate with nickname " + "nickname");
            startActivityForResult(intent, 101);
        }
    }
}
